Index: libgomp/ChangeLog
===================================================================
--- libgomp/ChangeLog	(.../tags/gcc_8_1_0_release)
+++ libgomp/ChangeLog	(.../branches/gcc-8-branch)
@@ -1,3 +1,13 @@
+2018-05-02  Tom de Vries  <tom@codesourcery.com>
+
+	backport from trunk:
+	2018-04-26  Tom de Vries  <tom@codesourcery.com>
+
+	PR target/85519
+	* testsuite/libgomp.fortran/examples-4/declare_target-1.f90: Reduce
+	recursion depth from 25 to 23.
+	* testsuite/libgomp.fortran/examples-4/declare_target-2.f90: Same.
+
 2018-05-02  Release Manager
 
 	* GCC 8.1.0 released.
Index: libgomp/testsuite/libgomp.fortran/examples-4/declare_target-1.f90
===================================================================
--- libgomp/testsuite/libgomp.fortran/examples-4/declare_target-1.f90	(.../tags/gcc_8_1_0_release)
+++ libgomp/testsuite/libgomp.fortran/examples-4/declare_target-1.f90	(.../branches/gcc-8-branch)
@@ -27,5 +27,7 @@
 program e_53_1
   use e_53_1_mod, only : fib, fib_wrapper
   if (fib (15) /= fib_wrapper (15)) STOP 1
-  if (fib (25) /= fib_wrapper (25)) STOP 2
+  ! Reduced from 25 to 23, otherwise execution runs out of thread stack on
+  ! Nvidia Titan V.
+  if (fib (23) /= fib_wrapper (23)) STOP 2
 end program
Index: libgomp/testsuite/libgomp.fortran/examples-4/declare_target-2.f90
===================================================================
--- libgomp/testsuite/libgomp.fortran/examples-4/declare_target-2.f90	(.../tags/gcc_8_1_0_release)
+++ libgomp/testsuite/libgomp.fortran/examples-4/declare_target-2.f90	(.../branches/gcc-8-branch)
@@ -4,9 +4,11 @@
   !$omp declare target (fib)
   integer :: x, fib
   !$omp target map(from: x)
-    x = fib (25)
+    ! Reduced from 25 to 23, otherwise execution runs out of thread stack on
+    ! Nvidia Titan V.
+    x = fib (23)
   !$omp end target
-  if (x /= fib (25)) STOP 1
+  if (x /= fib (23)) STOP 1
 end program
 
 integer recursive function fib (n) result (f)
Index: libstdc++-v3/src/filesystem/ops.cc
===================================================================
--- libstdc++-v3/src/filesystem/ops.cc	(.../tags/gcc_8_1_0_release)
+++ libstdc++-v3/src/filesystem/ops.cc	(.../branches/gcc-8-branch)
@@ -1132,10 +1132,11 @@
       ec.assign(errno, std::generic_category());
   else
     {
+      uintmax_t fragment_size = f.f_frsize;
       info = space_info{
-	f.f_blocks * f.f_frsize,
-	f.f_bfree * f.f_frsize,
-	f.f_bavail * f.f_frsize
+	f.f_blocks * fragment_size,
+	f.f_bfree * fragment_size,
+	f.f_bavail * fragment_size
       };
       ec.clear();
     }
Index: libstdc++-v3/src/filesystem/std-ops.cc
===================================================================
--- libstdc++-v3/src/filesystem/std-ops.cc	(.../tags/gcc_8_1_0_release)
+++ libstdc++-v3/src/filesystem/std-ops.cc	(.../branches/gcc-8-branch)
@@ -1378,10 +1378,11 @@
       ec.assign(errno, std::generic_category());
   else
     {
+      uintmax_t fragment_size = f.f_frsize;
       info = space_info{
-	f.f_blocks * f.f_frsize,
-	f.f_bfree * f.f_frsize,
-	f.f_bavail * f.f_frsize
+	f.f_blocks * fragment_size,
+	f.f_bfree * fragment_size,
+	f.f_bavail * fragment_size
       };
       ec.clear();
     }
Index: libstdc++-v3/include/std/optional
===================================================================
--- libstdc++-v3/include/std/optional	(.../tags/gcc_8_1_0_release)
+++ libstdc++-v3/include/std/optional	(.../branches/gcc-8-branch)
@@ -82,8 +82,9 @@
   {
   public:
     bad_optional_access() { }
+
     virtual const char* what() const noexcept override
-    {return "bad optional access";}
+    { return "bad optional access"; }
 
     virtual ~bad_optional_access() noexcept = default;
   };
@@ -108,36 +109,40 @@
 	      is_trivially_move_assignable<_Tp>::value>
     struct _Optional_payload
     {
-      constexpr _Optional_payload()
-	: _M_empty() {}
+      constexpr _Optional_payload() noexcept : _M_empty() { }
 
       template <typename... _Args>
-      constexpr _Optional_payload(in_place_t, _Args&&... __args)
-	: _M_payload(std::forward<_Args>(__args)...),
-	  _M_engaged(true) {}
+	constexpr
+	_Optional_payload(in_place_t, _Args&&... __args)
+	: _M_payload(std::forward<_Args>(__args)...), _M_engaged(true) { }
 
       template<typename _Up, typename... _Args>
-      constexpr _Optional_payload(std::initializer_list<_Up> __il,
-				  _Args&&... __args)
+	constexpr
+	_Optional_payload(std::initializer_list<_Up> __il,
+			  _Args&&... __args)
 	: _M_payload(__il, std::forward<_Args>(__args)...),
-	  _M_engaged(true) {}
+	  _M_engaged(true)
+	{ }
+
       constexpr
       _Optional_payload(bool __engaged, const _Optional_payload& __other)
-	: _Optional_payload(__other)
-      {}
+      : _Optional_payload(__other)
+      { }
 
       constexpr
       _Optional_payload(bool __engaged, _Optional_payload&& __other)
-	: _Optional_payload(std::move(__other))
-      {}
+      : _Optional_payload(std::move(__other))
+      { }
 
-      constexpr _Optional_payload(const _Optional_payload& __other)
+      constexpr
+      _Optional_payload(const _Optional_payload& __other)
       {
 	if (__other._M_engaged)
 	  this->_M_construct(__other._M_payload);
       }
 
-      constexpr _Optional_payload(_Optional_payload&& __other)
+      constexpr
+      _Optional_payload(_Optional_payload&& __other)
       {
 	if (__other._M_engaged)
 	  this->_M_construct(std::move(__other._M_payload));
@@ -176,7 +181,9 @@
       }
 
       using _Stored_type = remove_const_t<_Tp>;
+
       struct _Empty_byte { };
+
       union {
           _Empty_byte _M_empty;
           _Stored_type _M_payload;
@@ -201,16 +208,12 @@
 
       // The _M_get operations have _M_engaged as a precondition.
       constexpr _Tp&
-	_M_get() noexcept
-      {
-	return this->_M_payload;
-      }
+      _M_get() noexcept
+      { return this->_M_payload; }
 
       constexpr const _Tp&
-	_M_get() const noexcept
-      {
-	return this->_M_payload;
-      }
+      _M_get() const noexcept
+      { return this->_M_payload; }
 
       // _M_reset is a 'safe' operation with no precondition.
       void
@@ -224,62 +227,64 @@
       }
     };
 
-  // Payload for constexpr optionals.
+  // Payload for potentially-constexpr optionals.
   template <typename _Tp>
     struct _Optional_payload<_Tp, true, true, true>
     {
-      constexpr _Optional_payload()
-	: _M_empty(), _M_engaged(false) {}
+      constexpr _Optional_payload() noexcept
+      : _M_empty(), _M_engaged(false) { }
 
       template<typename... _Args>
-      constexpr _Optional_payload(in_place_t, _Args&&... __args)
-	: _M_payload(std::forward<_Args>(__args)...),
-	  _M_engaged(true)
-      {}
+	constexpr
+	_Optional_payload(in_place_t, _Args&&... __args)
+	: _M_payload(std::forward<_Args>(__args)...), _M_engaged(true)
+	{ }
 
       template<typename _Up, typename... _Args>
-      constexpr _Optional_payload(std::initializer_list<_Up> __il,
-				  _Args&&... __args)
+	constexpr
+	_Optional_payload(std::initializer_list<_Up> __il,
+			  _Args&&... __args)
 	: _M_payload(__il, std::forward<_Args>(__args)...),
-	  _M_engaged(true) {}
+	  _M_engaged(true)
+	{ }
 
       template <class _Up> struct __ctor_tag {};
 
-      constexpr _Optional_payload(__ctor_tag<bool>,
-				  const _Tp& __other)
-	: _M_payload(__other),
-	  _M_engaged(true)
-      {}
+      constexpr
+      _Optional_payload(__ctor_tag<bool>, const _Tp& __other)
+      : _M_payload(__other), _M_engaged(true)
+      { }
 
-      constexpr _Optional_payload(__ctor_tag<void>)
-	: _M_empty(), _M_engaged(false)
-      {}
+      constexpr _Optional_payload(__ctor_tag<void>) noexcept
+      : _M_empty(), _M_engaged(false)
+      { }
 
       constexpr _Optional_payload(__ctor_tag<bool>, _Tp&& __other)
-	: _M_payload(std::move(__other)),
-	  _M_engaged(true)
-      {}
+      : _M_payload(std::move(__other)), _M_engaged(true)
+      { }
 
-      constexpr _Optional_payload(bool __engaged,
-				  const _Optional_payload& __other)
-	: _Optional_payload(__engaged ?
-			    _Optional_payload(__ctor_tag<bool>{},
-					      __other._M_payload) :
-			    _Optional_payload(__ctor_tag<void>{}))
-      {}
+      constexpr
+      _Optional_payload(bool __engaged, const _Optional_payload& __other)
+      : _Optional_payload(__engaged ?
+			  _Optional_payload(__ctor_tag<bool>{},
+					    __other._M_payload) :
+			  _Optional_payload(__ctor_tag<void>{}))
+      { }
 
-      constexpr _Optional_payload(bool __engaged,
-				  _Optional_payload&& __other)
-	: _Optional_payload(__engaged
-			    ? _Optional_payload(__ctor_tag<bool>{},
-						std::move(__other._M_payload))
-			    : _Optional_payload(__ctor_tag<void>{}))
-      {}
+      constexpr
+      _Optional_payload(bool __engaged, _Optional_payload&& __other)
+      : _Optional_payload(__engaged
+			  ? _Optional_payload(__ctor_tag<bool>{},
+					      std::move(__other._M_payload))
+			  : _Optional_payload(__ctor_tag<void>{}))
+      { }
 
       using _Stored_type = remove_const_t<_Tp>;
+
       struct _Empty_byte { };
+
       union {
-          _Empty_byte _M_empty;
+	  _Empty_byte _M_empty;
           _Stored_type _M_payload;
       };
       bool _M_engaged;
@@ -289,53 +294,54 @@
   template <typename _Tp>
     struct _Optional_payload<_Tp, true, false, true>
     {
-      constexpr _Optional_payload()
-	: _M_empty(), _M_engaged(false) {}
+      constexpr _Optional_payload() noexcept
+      : _M_empty(), _M_engaged(false) { }
 
       template<typename... _Args>
-      constexpr _Optional_payload(in_place_t, _Args&&... __args)
-	: _M_payload(std::forward<_Args>(__args)...),
-	  _M_engaged(true)
-      {}
+	constexpr
+	_Optional_payload(in_place_t, _Args&&... __args)
+	: _M_payload(std::forward<_Args>(__args)...), _M_engaged(true)
+	{ }
 
       template<typename _Up, typename... _Args>
-      constexpr _Optional_payload(std::initializer_list<_Up> __il,
-				  _Args&&... __args)
+	constexpr
+	_Optional_payload(std::initializer_list<_Up> __il,
+			  _Args&&... __args)
 	: _M_payload(__il, std::forward<_Args>(__args)...),
-	  _M_engaged(true) {}
+	  _M_engaged(true)
+	{ }
 
       template <class _Up> struct __ctor_tag {};
 
-      constexpr _Optional_payload(__ctor_tag<bool>,
-				  const _Tp& __other)
-	: _M_payload(__other),
-	  _M_engaged(true)
-      {}
+      constexpr _Optional_payload(__ctor_tag<bool>, const _Tp& __other)
+      : _M_payload(__other),
+	_M_engaged(true)
+      { }
 
-      constexpr _Optional_payload(__ctor_tag<void>)
-	: _M_empty(), _M_engaged(false)
-      {}
+      constexpr _Optional_payload(__ctor_tag<void>) noexcept
+      : _M_empty(), _M_engaged(false)
+      { }
 
       constexpr _Optional_payload(__ctor_tag<bool>, _Tp&& __other)
-	: _M_payload(std::move(__other)),
-	  _M_engaged(true)
-      {}
+      : _M_payload(std::move(__other)),
+	_M_engaged(true)
+      { }
 
-      constexpr _Optional_payload(bool __engaged,
-				  const _Optional_payload& __other)
-	: _Optional_payload(__engaged ?
-			    _Optional_payload(__ctor_tag<bool>{},
-					      __other._M_payload) :
-			    _Optional_payload(__ctor_tag<void>{}))
-      {}
+      constexpr
+      _Optional_payload(bool __engaged, const _Optional_payload& __other)
+      : _Optional_payload(__engaged ?
+			  _Optional_payload(__ctor_tag<bool>{},
+					    __other._M_payload) :
+			  _Optional_payload(__ctor_tag<void>{}))
+      { }
 
-      constexpr _Optional_payload(bool __engaged,
-				  _Optional_payload&& __other)
-	: _Optional_payload(__engaged
-			    ? _Optional_payload(__ctor_tag<bool>{},
-						std::move(__other._M_payload))
-			    : _Optional_payload(__ctor_tag<void>{}))
-      {}
+      constexpr
+      _Optional_payload(bool __engaged, _Optional_payload&& __other)
+      : _Optional_payload(__engaged
+			  ? _Optional_payload(__ctor_tag<bool>{},
+					      std::move(__other._M_payload))
+			  : _Optional_payload(__ctor_tag<void>{}))
+      { }
 
       _Optional_payload(const _Optional_payload&) = default;
       _Optional_payload(_Optional_payload&&) = default;
@@ -359,7 +365,9 @@
       operator=(_Optional_payload&& __other) = default;
 
       using _Stored_type = remove_const_t<_Tp>;
+
       struct _Empty_byte { };
+
       union {
           _Empty_byte _M_empty;
           _Stored_type _M_payload;
@@ -378,16 +386,12 @@
 
       // The _M_get operations have _M_engaged as a precondition.
       constexpr _Tp&
-	_M_get() noexcept
-      {
-	return this->_M_payload;
-      }
+      _M_get() noexcept
+      { return this->_M_payload; }
 
       constexpr const _Tp&
-	_M_get() const noexcept
-      {
-	return this->_M_payload;
-      }
+      _M_get() const noexcept
+      { return this->_M_payload; }
 
       // _M_reset is a 'safe' operation with no precondition.
       void
@@ -405,53 +409,56 @@
   template <typename _Tp>
     struct _Optional_payload<_Tp, true, true, false>
     {
-      constexpr _Optional_payload()
-	: _M_empty(), _M_engaged(false) {}
+      constexpr _Optional_payload() noexcept
+      : _M_empty(), _M_engaged(false) { }
 
       template<typename... _Args>
-      constexpr _Optional_payload(in_place_t, _Args&&... __args)
+	constexpr
+	_Optional_payload(in_place_t, _Args&&... __args)
 	: _M_payload(std::forward<_Args>(__args)...),
 	  _M_engaged(true)
-      {}
+	{ }
 
       template<typename _Up, typename... _Args>
-      constexpr _Optional_payload(std::initializer_list<_Up> __il,
-				  _Args&&... __args)
+	constexpr
+	_Optional_payload(std::initializer_list<_Up> __il,
+			  _Args&&... __args)
 	: _M_payload(__il, std::forward<_Args>(__args)...),
-	  _M_engaged(true) {}
+	  _M_engaged(true)
+	{ }
 
       template <class _Up> struct __ctor_tag {};
 
-      constexpr _Optional_payload(__ctor_tag<bool>,
-				  const _Tp& __other)
-	: _M_payload(__other),
-	  _M_engaged(true)
-      {}
+      constexpr
+      _Optional_payload(__ctor_tag<bool>, const _Tp& __other)
+      : _M_payload(__other),
+	_M_engaged(true)
+      { }
 
-      constexpr _Optional_payload(__ctor_tag<void>)
-	: _M_empty(), _M_engaged(false)
-      {}
+      constexpr _Optional_payload(__ctor_tag<void>) noexcept
+      : _M_empty(), _M_engaged(false)
+      { }
 
       constexpr _Optional_payload(__ctor_tag<bool>, _Tp&& __other)
-	: _M_payload(std::move(__other)),
-	  _M_engaged(true)
-      {}
+      : _M_payload(std::move(__other)),
+	_M_engaged(true)
+      { }
 
-      constexpr _Optional_payload(bool __engaged,
-				  const _Optional_payload& __other)
-	: _Optional_payload(__engaged ?
-			    _Optional_payload(__ctor_tag<bool>{},
-					      __other._M_payload) :
-			    _Optional_payload(__ctor_tag<void>{}))
-      {}
+      constexpr
+      _Optional_payload(bool __engaged, const _Optional_payload& __other)
+      : _Optional_payload(__engaged ?
+			  _Optional_payload(__ctor_tag<bool>{},
+					    __other._M_payload) :
+			  _Optional_payload(__ctor_tag<void>{}))
+      { }
 
-      constexpr _Optional_payload(bool __engaged,
-				  _Optional_payload&& __other)
-	: _Optional_payload(__engaged
-			    ? _Optional_payload(__ctor_tag<bool>{},
-						std::move(__other._M_payload))
-			    : _Optional_payload(__ctor_tag<void>{}))
-      {}
+      constexpr
+      _Optional_payload(bool __engaged, _Optional_payload&& __other)
+      : _Optional_payload(__engaged
+			  ? _Optional_payload(__ctor_tag<bool>{},
+					      std::move(__other._M_payload))
+			  : _Optional_payload(__ctor_tag<void>{}))
+      { }
 
       _Optional_payload(const _Optional_payload&) = default;
       _Optional_payload(_Optional_payload&&) = default;
@@ -477,7 +484,9 @@
       }
 
       using _Stored_type = remove_const_t<_Tp>;
+
       struct _Empty_byte { };
+
       union {
           _Empty_byte _M_empty;
           _Stored_type _M_payload;
@@ -496,16 +505,12 @@
 
       // The _M_get operations have _M_engaged as a precondition.
       constexpr _Tp&
-	_M_get() noexcept
-      {
-	return this->_M_payload;
-      }
+      _M_get() noexcept
+      { return this->_M_payload; }
 
       constexpr const _Tp&
-	_M_get() const noexcept
-      {
-	return this->_M_payload;
-      }
+      _M_get() const noexcept
+      { return this->_M_payload; }
 
       // _M_reset is a 'safe' operation with no precondition.
       void
@@ -523,53 +528,55 @@
   template <typename _Tp>
     struct _Optional_payload<_Tp, true, false, false>
     {
-      constexpr _Optional_payload()
-	: _M_empty(), _M_engaged(false) {}
+      constexpr _Optional_payload() noexcept
+      : _M_empty(), _M_engaged(false) {}
 
       template<typename... _Args>
-      constexpr _Optional_payload(in_place_t, _Args&&... __args)
+	constexpr
+	_Optional_payload(in_place_t, _Args&&... __args)
 	: _M_payload(std::forward<_Args>(__args)...),
 	  _M_engaged(true)
-      {}
+	{ }
 
       template<typename _Up, typename... _Args>
-      constexpr _Optional_payload(std::initializer_list<_Up> __il,
-				  _Args&&... __args)
+	constexpr
+	_Optional_payload(std::initializer_list<_Up> __il,
+			  _Args&&... __args)
 	: _M_payload(__il, std::forward<_Args>(__args)...),
-	  _M_engaged(true) {}
+	  _M_engaged(true)
+	{ }
 
       template <class _Up> struct __ctor_tag {};
 
-      constexpr _Optional_payload(__ctor_tag<bool>,
-				  const _Tp& __other)
-	: _M_payload(__other),
-	  _M_engaged(true)
-      {}
+      constexpr _Optional_payload(__ctor_tag<bool>, const _Tp& __other)
+      : _M_payload(__other),
+	    _M_engaged(true)
+      { }
 
-      constexpr _Optional_payload(__ctor_tag<void>)
-	: _M_empty(), _M_engaged(false)
-      {}
+      constexpr _Optional_payload(__ctor_tag<void>) noexcept
+      : _M_empty(), _M_engaged(false)
+      { }
 
       constexpr _Optional_payload(__ctor_tag<bool>, _Tp&& __other)
-	: _M_payload(std::move(__other)),
-	  _M_engaged(true)
-      {}
+      : _M_payload(std::move(__other)),
+	_M_engaged(true)
+      { }
 
-      constexpr _Optional_payload(bool __engaged,
-				  const _Optional_payload& __other)
-	: _Optional_payload(__engaged ?
-			    _Optional_payload(__ctor_tag<bool>{},
-					      __other._M_payload) :
-			    _Optional_payload(__ctor_tag<void>{}))
-      {}
+      constexpr
+      _Optional_payload(bool __engaged, const _Optional_payload& __other)
+      : _Optional_payload(__engaged ?
+			  _Optional_payload(__ctor_tag<bool>{},
+					    __other._M_payload) :
+			  _Optional_payload(__ctor_tag<void>{}))
+      { }
 
-      constexpr _Optional_payload(bool __engaged,
-				  _Optional_payload&& __other)
-	: _Optional_payload(__engaged
-			    ? _Optional_payload(__ctor_tag<bool>{},
-						std::move(__other._M_payload))
-			    : _Optional_payload(__ctor_tag<void>{}))
-      {}
+      constexpr
+      _Optional_payload(bool __engaged, _Optional_payload&& __other)
+      : _Optional_payload(__engaged
+			  ? _Optional_payload(__ctor_tag<bool>{},
+					      std::move(__other._M_payload))
+			  : _Optional_payload(__ctor_tag<void>{}))
+      { }
 
       _Optional_payload(const _Optional_payload&) = default;
       _Optional_payload(_Optional_payload&&) = default;
@@ -607,7 +614,9 @@
       }
 
       using _Stored_type = remove_const_t<_Tp>;
+
       struct _Empty_byte { };
+
       union {
           _Empty_byte _M_empty;
           _Stored_type _M_payload;
@@ -626,16 +635,12 @@
 
       // The _M_get operations have _M_engaged as a precondition.
       constexpr _Tp&
-	_M_get() noexcept
-      {
-	return this->_M_payload;
-      }
+      _M_get() noexcept
+      { return this->_M_payload; }
 
       constexpr const _Tp&
-	_M_get() const noexcept
-      {
-	return this->_M_payload;
-      }
+      _M_get() const noexcept
+      { return this->_M_payload; }
 
       // _M_reset is a 'safe' operation with no precondition.
       void
@@ -658,15 +663,15 @@
       // The _M_construct operation has !_M_engaged as a precondition
       // while _M_destruct has _M_engaged as a precondition.
       template<typename... _Args>
-      void
-      _M_construct(_Args&&... __args)
+	void
+	_M_construct(_Args&&... __args)
 	noexcept(is_nothrow_constructible<_Stored_type, _Args...>())
-      {
-	::new
-	  (std::__addressof(static_cast<_Dp*>(this)->_M_payload._M_payload))
-	  _Stored_type(std::forward<_Args>(__args)...);
-	static_cast<_Dp*>(this)->_M_payload._M_engaged = true;
-      }
+	{
+	  ::new
+	    (std::__addressof(static_cast<_Dp*>(this)->_M_payload._M_payload))
+	    _Stored_type(std::forward<_Args>(__args)...);
+	  static_cast<_Dp*>(this)->_M_payload._M_engaged = true;
+	}
       
       void
       _M_destruct() noexcept
@@ -700,8 +705,8 @@
       : protected _Optional_base_impl<_Tp, _Optional_base<_Tp>>
     {
       friend class _Optional_base_impl<_Tp, _Optional_base<_Tp>>;
+
     public:
-
       // Constructors for disengaged optionals.
       constexpr _Optional_base() = default;
 
Index: libstdc++-v3/include/std/variant
===================================================================
--- libstdc++-v3/include/std/variant	(.../tags/gcc_8_1_0_release)
+++ libstdc++-v3/include/std/variant	(.../branches/gcc-8-branch)
@@ -1389,7 +1389,7 @@
 
       using _Result_type =
 	decltype(std::forward<_Visitor>(__visitor)(
-	    get<0>(std::forward<_Variants>(__variants))...));
+	    std::get<0>(std::forward<_Variants>(__variants))...));
 
       constexpr auto& __vtable = __detail::__variant::__gen_vtable<
 	_Result_type, _Visitor&&, _Variants&&...>::_S_vtable;
Index: libstdc++-v3/ChangeLog
===================================================================
--- libstdc++-v3/ChangeLog	(.../tags/gcc_8_1_0_release)
+++ libstdc++-v3/ChangeLog	(.../branches/gcc-8-branch)
@@ -1,3 +1,31 @@
+2018-05-04  Jonathan Wakely  <jwakely@redhat.com>
+
+	PR libstdc++/85642 fix is_nothrow_default_constructible<optional<T>>
+	* include/std/optional (_Optional_payload): Add noexcept to default
+	constructor. Re-indent.
+	(_Optional_payload<_Tp, true, true, true>): Likewise. Add noexcept to
+	constructor for copying disengaged payloads.
+	(_Optional_payload<_Tp, true, false, true>): Likewise.
+	(_Optional_payload<_Tp, true, true, false>): Likewise.
+	(_Optional_payload<_Tp, true, false, false>): Likewise.
+	* testsuite/20_util/optional/cons/85642.cc: New.
+	* testsuite/20_util/optional/cons/value_neg.cc: Adjust dg-error lines.
+
+2018-05-03  Jonathan Wakely  <jwakely@redhat.com>
+
+	PR libstdc++/84769
+	* include/std/variant (visit): Qualify std::get call.
+
+2018-05-03  Jonathan Wakely  <jwakely@redhat.com>
+
+	PR libstdc++/85632 use uintmax_t for arithmetic
+	* src/filesystem/ops.cc (experimental::filesystem::space): Perform
+	arithmetic in result type.
+	* src/filesystem/std-ops.cc (filesystem::space): Likewise.
+	* testsuite/27_io/filesystem/operations/space.cc: Check total capacity
+	is greater than free space.
+	* testsuite/experimental/filesystem/operations/space.cc: New.
+
 2018-05-02  Release Manager
 
 	* GCC 8.1.0 released.
Index: libstdc++-v3/testsuite/27_io/filesystem/operations/space.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/filesystem/operations/space.cc	(.../tags/gcc_8_1_0_release)
+++ libstdc++-v3/testsuite/27_io/filesystem/operations/space.cc	(.../branches/gcc-8-branch)
@@ -32,6 +32,7 @@
   std::error_code ec = make_error_code(std::errc::invalid_argument);
   s = std::filesystem::space("/", ec);
   VERIFY( !ec );
+
   s = std::filesystem::space(__gnu_test::nonexistent_path(), ec);
   VERIFY( ec );
   VERIFY( s.capacity ==  static_cast<uintmax_t>(-1) );
@@ -39,8 +40,16 @@
   VERIFY( s.available ==  static_cast<uintmax_t>(-1) );
 }
 
+void
+test02()
+{
+  std::filesystem::space_info s = std::filesystem::space(".");
+  VERIFY( s.capacity >= s.free );
+}
+
 int
 main()
 {
   test01();
+  test02();
 }
Index: libstdc++-v3/testsuite/experimental/filesystem/operations/space.cc
===================================================================
--- libstdc++-v3/testsuite/experimental/filesystem/operations/space.cc	(.../tags/gcc_8_1_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ libstdc++-v3/testsuite/experimental/filesystem/operations/space.cc	(.../branches/gcc-8-branch)
@@ -0,0 +1,57 @@
+// Copyright (C) 2017-2018 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-options "-DUSE_FILESYSTEM_TS -lstdc++fs" }
+// { dg-do run { target c++11 } }
+// { dg-require-filesystem-ts "" }
+
+// 30.10.14.3 Permissions [fs.op.space]
+
+#include <experimental/filesystem>
+#include <testsuite_fs.h>
+#include <testsuite_hooks.h>
+
+namespace fs = std::experimental::filesystem;
+
+void
+test01()
+{
+  fs::space_info s = fs::space("/");
+  std::error_code ec = make_error_code(std::errc::invalid_argument);
+  s = fs::space("/", ec);
+  VERIFY( !ec );
+
+  s = fs::space(__gnu_test::nonexistent_path(), ec);
+  VERIFY( ec );
+  VERIFY( s.capacity ==  static_cast<uintmax_t>(-1) );
+  VERIFY( s.free ==  static_cast<uintmax_t>(-1) );
+  VERIFY( s.available ==  static_cast<uintmax_t>(-1) );
+}
+
+void
+test02()
+{
+  fs::space_info s = fs::space(".");
+  VERIFY( s.capacity >= s.free );
+}
+
+int
+main()
+{
+  test01();
+  test02();
+}
Index: libstdc++-v3/testsuite/20_util/optional/cons/value_neg.cc
===================================================================
--- libstdc++-v3/testsuite/20_util/optional/cons/value_neg.cc	(.../tags/gcc_8_1_0_release)
+++ libstdc++-v3/testsuite/20_util/optional/cons/value_neg.cc	(.../branches/gcc-8-branch)
@@ -37,8 +37,8 @@
     std::optional<std::unique_ptr<int>> oup2 = new int;  // { dg-error "conversion" }
     struct U { explicit U(std::in_place_t); };
     std::optional<U> ou(std::in_place); // { dg-error "no matching" }
-    // { dg-error "no type" "" { target { *-*-* } } 1015 }
-    // { dg-error "no type" "" { target { *-*-* } } 1025 }
-    // { dg-error "no type" "" { target { *-*-* } } 1082 }
+    // { dg-error "no type" "" { target { *-*-* } } 1020 }
+    // { dg-error "no type" "" { target { *-*-* } } 1030 }
+    // { dg-error "no type" "" { target { *-*-* } } 1087 }
   }
 }
Index: libstdc++-v3/testsuite/20_util/optional/cons/85642.cc
===================================================================
--- libstdc++-v3/testsuite/20_util/optional/cons/85642.cc	(.../tags/gcc_8_1_0_release)	1970-01-01 01:00:00.000000000 +0100
+++ libstdc++-v3/testsuite/20_util/optional/cons/85642.cc	(.../branches/gcc-8-branch)
@@ -0,0 +1,63 @@
+// Copyright (C) 2018 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-options "-std=gnu++17" }
+// { dg-do compile { target c++17 } }
+
+#include <optional>
+
+struct NonTrivialDtor {
+  ~NonTrivialDtor() { }
+};
+
+struct NonTrivialCopyAssign {
+  NonTrivialCopyAssign& operator=(const NonTrivialCopyAssign&) { return *this; }
+  NonTrivialCopyAssign& operator=(NonTrivialCopyAssign&&) = default;
+};
+
+struct NonTrivialMoveAssign {
+  NonTrivialMoveAssign& operator=(const NonTrivialMoveAssign&) = default;
+  NonTrivialMoveAssign& operator=(NonTrivialMoveAssign&&) { return *this; }
+};
+
+struct NonTrivialAssign {
+  NonTrivialAssign& operator=(const NonTrivialAssign&) { return *this; }
+  NonTrivialAssign& operator=(NonTrivialAssign&&) { return *this; }
+};
+
+struct NonTrivialAll {
+  ~NonTrivialAll() { }
+  NonTrivialAll& operator=(const NonTrivialAll&) { return *this; }
+  NonTrivialAll& operator=(NonTrivialAll&&) { return *this; }
+};
+
+struct ConstExpr { int i = 0; };
+
+struct Trivial { int i; };
+
+template<typename T>
+  constexpr bool check
+    = std::is_nothrow_default_constructible_v<std::optional<T>>;
+
+// PR libstdc++/85642
+static_assert(check<NonTrivialDtor>);
+static_assert(check<NonTrivialCopyAssign>);
+static_assert(check<NonTrivialMoveAssign>);
+static_assert(check<NonTrivialAssign>);
+static_assert(check<NonTrivialAll>);
+static_assert(check<ConstExpr>);
+static_assert(check<Trivial>);
Index: gcc/DATESTAMP
===================================================================
--- gcc/DATESTAMP	(.../tags/gcc_8_1_0_release)
+++ gcc/DATESTAMP	(.../branches/gcc-8-branch)
@@ -1 +1 @@
-20180502
+20180504
Index: gcc/ChangeLog
===================================================================
--- gcc/ChangeLog	(.../tags/gcc_8_1_0_release)
+++ gcc/ChangeLog	(.../branches/gcc-8-branch)
@@ -1,3 +1,7 @@
+2018-05-02  Jakub Jelinek  <jakub@redhat.com>
+
+	* BASE-VER: Set to 8.1.1.
+
 2018-05-02  Release Manager
 
 	* GCC 8.1.0 released.
Index: gcc/ada/init.c
===================================================================
--- gcc/ada/init.c	(.../tags/gcc_8_1_0_release)
+++ gcc/ada/init.c	(.../branches/gcc-8-branch)
@@ -1279,7 +1279,7 @@
 
   /* If it was a DEC Ada specific condtiion, make it GNAT otherwise
      keep the old facility.  */
-  if (sigargs [1] & FAC_MASK == DECADA_M_FACILITY)
+  if ((sigargs [1] & FAC_MASK) == DECADA_M_FACILITY)
     SYS$PUTMSG (sigargs, copy_msg, &gnat_facility,
 	        (unsigned long long ) message);
   else
Index: gcc/ada/ChangeLog
===================================================================
--- gcc/ada/ChangeLog	(.../tags/gcc_8_1_0_release)
+++ gcc/ada/ChangeLog	(.../branches/gcc-8-branch)
@@ -1,3 +1,13 @@
+2018-05-04  John Marino  <gnugcc@marino.st>
+
+	PR ada/85635
+	* link.c (BSD platforms): Add missing backslash.
+
+2018-05-04  Eric Botcazou  <ebotcazou@adacore.com>
+
+	PR ada/85540
+	* init.c (__gnat_handle_vms_condition): Add missing parentheses.
+
 2018-05-02  Release Manager
 
 	* GCC 8.1.0 released.
Index: gcc/ada/link.c
===================================================================
--- gcc/ada/link.c	(.../tags/gcc_8_1_0_release)
+++ gcc/ada/link.c	(.../branches/gcc-8-branch)
@@ -104,7 +104,7 @@
 const char *__gnat_default_libgcc_subdir = "lib";
 
 #elif defined (__FreeBSD__) || defined (__DragonFly__) \
-   || defined (__NetBSD__) || defined (__OpenBSD__)
+   || defined (__NetBSD__) || defined (__OpenBSD__) \
    || defined (__QNX__)
 const char *__gnat_object_file_option = "-Wl,@";
 const char *__gnat_run_path_option = "-Wl,-rpath,";
Index: gcc/BASE-VER
===================================================================
--- gcc/BASE-VER	(.../tags/gcc_8_1_0_release)
+++ gcc/BASE-VER	(.../branches/gcc-8-branch)
@@ -1 +1 @@
-8.1.0
+8.1.1
